#!/bin/bash
# set -x
# Acritox' Installer - Backend

function print_usage()
{
cat <<EOF >&2
$(basename $0):

 -ni
        NonInteractive mode, no prompt is shown and INSTALLER_OUTPUT is set to 1
 -e command
        Run "command"

EOF
exit 0
}

function set_debug()
{
    case $1 in
    on)
        PS4="<acritoxinstaller debug> "
        set -x
        ;;
    off)
        set +x
        PS4="+"
        ;;
    esac
}

SEARCHPATH="/usr/share/acritoxinstaller"
[ ! -e "$SEARCHPATH" -a -e ./modules ] && SEARCHPATH="."

for i in $(find $SEARCHPATH/modules/ -type f | sort); do
	source $i
done

if ((UID)); then
	for as_root in sudo kdesu gksu exec
	do
		[ -x /usr/bin/$as_root ] && break
	done
	$as_root "$0" "$@"
	exit $?
fi

while [ "$1" ]
do
	case $1 in
	"-ni")
		export INSTALLER_OUTPUT=1
		;;
	"-e")
		shift
		eval "$@"
		exit $?
		;;
	"-h")
		print_usage
		;;
	esac
	shift
done

while true
do
	if ((INSTALLER_OUTPUT)); then
        echo "<acritoxinstaller backend prompt>"
	else
	echo -n "acritox' installer> "
	fi
	IFS=" " read -r command params
	declare -F ${command}_pre &>/dev/null && eval "${command}_pre"
	eval "$command $params"
	declare -F ${command}_post &>/dev/null && eval "${command}_post"
done
